Unit de70ek_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure de70ek(K :Integer; var RABC :Array of Extended;
                var ALP :Array of Extended; var ALPN :Array of Extended;
                var CMAR :Array of Extended; var P :Array of Extended;
                var S :Array of Extended);

implementation

procedure de70ek(K :Integer; var RABC :Array of Extended;
                var ALP :Array of Extended; var ALPN :Array of Extended;
                var CMAR :Array of Extended; var P :Array of Extended;
                var S :Array of Extended);
var
KM1,J,JM1,I,IPNS,IPN :Integer;
PI,R,WC0,W :Extended;
label
_10,_15,_20,_25,_30,_35,_40,_50,_55,_60;
begin
PI := 3.1415926535897932385e0;
{      PI=3.14_159_265_358_979_323_85 }
{        CONSTRUCTION OF PASCAL MATRIX }
KM1 := K-1;
for J:=1 to KM1 do
 begin
_10:
  CMAR[(J-1)+(J-1)*K] := 1.0e0;
 end;
for J:=2 to K do
 begin
  CMAR[0+(J-1)*K] := (J);
  if ( J  =  2 ) 
   then goto _20;
  JM1 := J-1;
  for I:=2 to JM1 do
   begin
    CMAR[(I-1)+(J-1)*K] := CMAR[(I-2)+(JM1-1)*K]+CMAR[(I-1)+(JM1-1)*K];
_15:
   end;
_20:
 end;
{        DISPLACEMENT OF PASCAL MATRIX }
S[0] := 1.0e0;
for J:=1 to K do
 begin
_25:
  S[J+0] := S[J-1]*2.0e0;
 end;
IPNS := K+1;
IPN := 0;
for I:=1 to KM1 do
 begin
  R := 0.5e0;
  for J:=I to K do
   begin
    IPN := IPN+1;
    IPNS := IPNS+1;
    P[IPN-1] := CMAR[(I-1)+(J-1)*K];
    R := R*2.0e0;
    S[IPNS-1] := CMAR[(I-1)+(J-1)*K]*R;
_30:
   end;
_35:
 end;
{        CALCULATE OF MARKOV COEFFICIENTS }
WC0 := 1.0e0/(2*K+1);
_COM70D.elm1 := PI*WC0;
_COM70D.elm2 := 2.0e0*WC0;
_COM70D.elm3 := 4.0e0*WC0;
_COM70D.elm4 := K+1-((K) Mod (2));
{        COEFFICIENTS MARKOV FOR A1 }
for J:=1 to K do
 begin
  W := (2*J-1)*_COM70D.elm1;
  ALPN[J-1] := Cos(W);
  ALP[J-1] := (1.0e0+ALPN[J-1])*0.5e0;
  CMAR[0+(J-1)*K] := ALPN[J-1];
_40:
 end;
{        COEFFICIENTS MARKOV FOR A2,...,AK }
for J:=1 to K do
 begin
  R := (2*J-1)*_COM70D.elm1;
  for I:=2 to K do
   begin
    CMAR[(I-1)+(J-1)*K] := Cos((I)*R);
{        CMAR(I,J)=DE70eT(I,ALPN(J)) }
_50:
   end;
_55:
 end;
for J:=2 to K do
 begin
  RABC[J-1] := 1.0e0/(J*J-1);
_60:
 end;
end;

end.
